#include "FiveWin.ch"

STATIC c_path, c_path1, lRun := .F., nBrush := 3, oMeter1, oABtn[3]
STATIC oImage, cType, nRecords := 1, nRecPos := 0, nDBF := 5, oRecords, nCounter := 0 
STATIC nStep, nSpeed, nDelay, nFrames := 20, nFCount := 1, nCPUSpeed 

FUNCTION MAIN()
LOCAL oDlg, oSBtn[7], oTextFont, oRad1, oRad2, nTyp := 1, oSay[5], oLbx1, oLbx2, cDelay := "0", cStep := "20"  
LOCAL oTextFont1, oTextFont2, oCheck, oGet 

REQUEST DBFCDX
RDDSETDEFAULT ( "DBFCDX" )

c_path	:= cFilePath(GetModuleFileName( GetInstance() ) )
c_path1	:= c_Path + "IMAGES\"
SetBalloon( .T. ) // Balloon shape required for tooltips

DEFINE FONT oTextFont1 NAME "Arial" SIZE 0, -14
DEFINE FONT oTextFont2 NAME "Arial" SIZE 0, -16 BOLD

nStep := 20
nDelay := 0
cType := "A_"

nCPUSpeed := GetCPUSpeed() // 2799
// MsgAlert( nCPUSpeed, "CPU-speed" ) 

GET_INI()
cDelay := ALLTRIM(STR(nDelay))
cStep := ALLTRIM(STR(nStep))
IF cType = "A_"
	nTyp := 1
ELSEIF cType = "B_"
	nTyp := 2
ELSEIF cType = "C_"
	nTyp := 3
ENDIF

CHANGE_DBF()

// oTextFont := TFont():New( "Arial", 0, 12,.F.,.F.,  0,  0,  0,.F.,.F.)
hResources := GetResources()
SET RESOURCES TO c_path1 + "ANIBTN.dll"

DEFINE DIALOG oDlg ;
FROM  0, 0 TO 460, 500 PIXEL TITLE "INDEX-builder Release 4.2"  ICON "FAVORITE"   

@ 10, 90 IMAGE oImage RESOURCE "C_30"  OF oDlg ; // start-frame
SIZE 80, 80 PIXEL  NOBORDER
oImage:cTooltip := "Image"
oImage:lTransparent := .T.

@ 90, 80 BTNBMP oABtn[1] SIZE 80, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Index.bmp" ;
LEFT BORDER ;
PROMPT " &Build Index " ;
FONT oTextFont2 ;
ACTION ( 	lRun := .T., oMeter1:SetTotal( nRecords ), DBGOTOP(), ;
                METER_INIT( oMeter1, oTextFont2 ), ; 
                MAKE_INDEX( oMeter1, @nRecPos, oImage, oTextFont2 ), ;   
                oMeter1:Set( 0 ) ) 
oABtn[1]:lTransparent := .T.
oABtn[1]:cTooltip :=  { "Run" + CRLF + ;
                                 "Image-animation","RUN", 1, CLR_BLACK, 14089979 }

@ 113, 80 BTNBMP oABtn[2] SIZE 80, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Save.bmp" ;
LEFT BORDER ;
PROMPT " &Save values " ;
FONT oTextFont2 ;
ACTION SAVE_INI()
oABtn[2]:lTransparent := .T.
oABtn[2]:cTooltip :=  { "Save" + CRLF + ;
                                 "to INI-file","SAVE", 1, CLR_BLACK, 14089979 }

@ 136, 80 BTNBMP oABtn[3] SIZE 80, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Help.bmp" ;
LEFT BORDER ;
PROMPT " &Help " ;
FONT oTextFont2 ;
ACTION MAIN_HELP(oTextFont1)
oABtn[3]:lTransparent := .T.
oABtn[3]:cTooltip :=  { "Value-defines","HELP", 1, CLR_BLACK, 14089979 }


@ 5, 200 SAY oSay[1] PROMPT "Delay" SIZE 30, 12 FONT oTextFont1 COLOR 255 PIXEL
oSay[1]:lTransparent := .T.

@ 15, 200 LISTBOX oLbx1 VAR cDelay SIZE 40, 40 PIXEL ;
ITEMS   { "0", "10", "20", "40", "60", "80" } FONT oTextFont2 ;
BITMAPS { c_path1 + "Col_1.bmp", c_path1 + "Col_1.bmp", c_path1 + "Col_2.bmp", ;
                  c_path1 + "Col_3.bmp", c_path1 + "Col_4.bmp", c_path1 + "Col_5.bmp" } ;
ON CHANGE  ( nDelay := VAL(cDelay), oMeter1:SetTotal( nRecords ), DBGOTOP(), ;
                        METER_INIT( oMeter1, oTextFont2 ) ) 

@ 60, 200 SAY oSay[2] PROMPT "Steps" SIZE 30, 12 FONT oTextFont1 COLOR 255 PIXEL
oSay[2]:lTransparent := .T.
@ 70, 200 SAY oSay[3] PROMPT "( for calc. )" SIZE 40, 12 FONT oTextFont1 COLOR 255 PIXEL
oSay[3]:lTransparent := .T.

@ 80, 200 LISTBOX oLbx2 VAR cStep SIZE 40, 40 PIXEL ;
ITEMS   { "5", "10", "20", "50", "100", "200", "400" } FONT oTextFont2 ;
BITMAPS { c_path1 + "Col_1.bmp", c_path1 + "Col_1.bmp", c_path1 + "Col_2.bmp", c_path1 + "Col_3.bmp", ;
                 c_path1 + "Col_4.bmp", c_path1 + "Col_5.bmp", c_path1 + "Col_5.bmp" } ;
ON CHANGE  ( nStep := VAL(cStep), oMeter1:SetTotal( nRecords ), DBGOTOP(), ;
                        METER_INIT( oMeter1, oTextFont2 ) ) 

@ 5, 10 SAY oSay[4] PROMPT "Records" SIZE 30, 12 FONT oTextFont1 COLOR 255 PIXEL
oSay[4]:lTransparent := .T.

@ 15, 10 RADIO oRad1 VAR nDBF OF oDlg PIXEL ;
ITEMS "50","100", "500", "1000", "1500", "2500", "5000", "50000", "100000" _3D SIZE 42, 14 ;
HELPID 100, 101, 102, 103, 104, 105, 106, 107, 107 ;
ON CHANGE  ( NET_CLOSE( 3, 3 ), CHANGE_DBF(oMeter1), oMeter1:SetTotal( nRecords ), DBGOTOP(), ;
                        METER_INIT( oMeter1, oTextFont2 ) ) UPDATE
AEval( oRad1:aItems, { | oRad | oRad:lTransparent := .T., ;
					      oRad:SetFont ( oTextFont2 ), ;
                                              oRad:nClrText := 0 } )

@ 125, 195 RADIO oRad2 VAR nTyp OF oDlg PIXEL ;
ITEMS "Typ &1", "Typ &2", "Typ &3" _3D SIZE 50, 10 ;
HELPID 200, 201, 202 ;
ON CHANGE ( IIF( nTyp = 1, ( cType := "A_", nFrames := 20 ), NIL ), ;
			IIF( nTyp = 2, ( cType := "B_", nFrames := 18 ), NIL ), ;
			IIF( nTyp = 3, ( cType := "C_", nFrames := 12 ), NIL ) )
AEval( oRad2:aItems, { | oRad | oRad:lTransparent := .T., ;
					      oRad:SetFont ( oTextFont2 ), ;
                                              oRad:nClrText := 255 } )

@ 150, 10 SAY oSay[5] PROMPT "Building Index ...." FONT oTextFont1 COLOR 0 PIXEL
oSay[5]:lTransparent := .T.

@ 160, 10 METEREX oMeter1 VAR nRecPos SIZE 230, 15 TOTAL nRecords ROUND ROUNDSIZE 6 OF oDlg PIXEL  
//GRADIENT CHUNK { { 1/2, 16443068, 15775859 }, { 1/2, 15775859, 16443068 } }; // Defined Red / Green
//GRADIENT TRACK { { 1/2, 16443068, 255 }, { 1/2, 255, 16443068 } } // Start with 100 % red

oMeter1:aGrad := { { 1/2, 16443068, 15775859 }, { 1/2, 15775859, 16443068 } } 
oMeter1:aGradMet := { { 1/2, 11449590, 5464557 }, { 1/2, 5464557, 11449590 } }

METER_INIT( oMeter1, oTextFont2 )  

oMeter1:SetTotal( nRecords )

// -----------------------

@ 180, 25 BTNBMP oSBtn[1] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Color.bmp" ;
LEFT ;
PROMPT "&Color" ;
FONT oTextFont1 ;
ACTION ( nBrush := 1, DRAW_BACK( oDlg, 1, 16762767 ), oRad1:Refresh() )
oSBtn[1]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[1]:nLayout := 2
oSBtn[1]:SetColor( 128 )
oSBtn[1]:cTooltip :=  { "use color" + CRLF + ;
                               "Background","COLOR", 1, CLR_BLACK, 16762767 }

@ 180, 95 BTNBMP oSBtn[2] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Gradient.bmp" ;
LEFT ;
PROMPT "&Gradient" ;
FONT oTextFont1 ;
ACTION ( nBrush := 2, DRAW_BACK( oDlg, 2, 16762767, 16773088, .T., 0.2 ) ) 
oSBtn[2]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[2]:nLayout := 2
oSBtn[2]:SetColor( 128 )
oSBtn[2]:cTooltip :=  { "use Gradient" + CRLF + ;
                               "Background","GRADIENT", 1, CLR_BLACK, 14089979 }

@ 180, 165 BTNBMP oSBtn[3] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Brush1.bmp" ;
LEFT ;
PROMPT "&Brush" ;
FONT oTextFont1 ;
ACTION ( nBrush := 3, DRAW_BACK( oDlg, 3, , , , , "Marble.bmp" ) )
oSBtn[3]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[3]:nLayout := 2
oSBtn[3]:SetColor( 128 )
oSBtn[3]:cTooltip :=  { "use Brush" + CRLF + ;
                               "Background","BRUSH", 1, CLR_BLACK, 14089979 }

@ 205, 25 BTNBMP oSBtn[4] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Image.bmp" ;
LEFT ;
PROMPT "&Image" ;
FONT oTextFont1 ;
ACTION ( nBrush := 4, DRAW_BACK( oDlg, 4, , , , , ,"Picture.jpg" ) ) 
oSBtn[4]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[4]:nLayout := 2
oSBtn[4]:SetColor( 128 )
oSBtn[4]:cTooltip :=  { "use Image" + CRLF + ;
                               "Background","IMAGE", 1, CLR_BLACK, 14089979 }

@ 205, 95 BTNBMP oSBtn[5] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Stop.bmp" ;
LEFT ;
PROMPT "&STOP ani." ;
FONT oTextFont1 ;
ACTION lRun := .F.  
oSBtn[5]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[5]:nLayout := 2
oSBtn[5]:SetColor( 128 )
oSBtn[5]:cTooltip :=  { "STOP" + CRLF + ;
                                "animation","STOP", 1, CLR_BLACK, 14089979 }

@ 205, 166 BTNBMP oSBtn[6] SIZE 60, 20 OF oDlg  2007 ;
FILENAME  c_path1 + "Exit.bmp" ;
LEFT ;
PROMPT "&Exit" ;
FONT oTextFont1 ;
ACTION oDlg:End() 
oSBtn[6]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 10526975, 16777215 }, ;
	  { 0.5, 16777215, 10526975 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[6]:nLayout := 2
oSBtn[6]:SetColor( 128 )
oSBtn[6]:cTooltip :=  { "Exit" + CRLF + ;
                                "Animation-Test","EXIT", 1, CLR_BLACK, 14089979 }

ACTIVATE DIALOG oDlg CENTERED ;
ON INIT DRAW_BACK( oDlg, nBrush, 16762767, 16773088, .T., 0.2, "Marble.bmp" , "Picture.jpg" )
 
SET RESOURCES TO
CLOSE DATABASE

oTextFont1:End()
oTextFont2:End()

RETURN NIL

// ------------------

FUNCTION METER_INIT( oMeter1, oTextFont2 )

oMeter1:bPainted := {|| oMeter1:Say( oMeter1:nHeight / 4.0, ;
			           ( oMeter1:nWidth/2 ) -40, STR( nCounter ), , ,oTextFont2 , .t., .t., 0 ) }

RETURN NIL

// --------  BACKGROUND ---------------

FUNCTION DRAW_BACK( oWnd, nStyle, nColor1, nColor2, lDirect, nMove, cBrush, cImage ) 
LOCAL hDC, oBrush, oImage, aGrad, I := 1
LOCAL aRect := GETCLIENTRECT( oWnd:hWnd ) 

IF nStyle = 1 // COLOR
	DEFINE BRUSH oBrush COLOR nColor1
ENDIF
IF nStyle = 2 // GRADIENT
	DEFINE BRUSH oBrush GRADIENT { { nMove, nColor1, nColor2 }, { nMove, nColor2, nColor1 } }
ENDIF
IF nStyle = 3 // BMP-BRUSH
	IF FILE( c_path1 + cBrush ) 
		DEFINE BRUSH oBrush FILE c_path1 + cBrush
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File : " + cBrush + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nStyle = 4 // Image ADJUSTED
	IF FILE( c_path1 + cImage ) 
		DEFINE IMAGE oImage FILE c_path1 + cImage
		oBrush := TBrush():new( ,,,, ResizeBmp( oImage:hBitmap, aRect[4], aRect[3], .T. ) ) 
		oImage:End()
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File  : " + cImage + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nBrush = 1
	oABtn[1]:SetColor( 255 )
	oABtn[2]:SetColor( 255 )
	oABtn[3]:SetColor( 255 )
ELSEIF nBrush = 2
	oABtn[1]:SetColor( 0 )
	oABtn[2]:SetColor( 0 )
	oABtn[3]:SetColor( 0 )
ELSEIF nBrush = 3
	oABtn[1]:SetColor( 255 )
	oABtn[2]:SetColor( 255 )
	oABtn[3]:SetColor( 255 )
ELSEIF nBrush = 4
	oABtn[1]:SetColor( 65535 )
	oABtn[2]:SetColor( 65535 )
	oABtn[3]:SetColor( 65535 )
ENDIF
oABtn[1]:Refresh()
oABtn[2]:Refresh()

oWnd:Setbrush( oBrush )

AEval( oWnd:aControls,{|o| if(o:ClassName() == "TRADIO", IIF( nBrush = 4, o:nClrText := 65535, o:nClrText := 0 ), ), ;
					 if(o:ClassName() == "TCHECKBOX", IIF( nBrush = 4, o:nClrText := 65535, o:nClrText := 0 ), ), ;
                                         if(o:ClassName() == "TSAY",     IIF( nBrush = 4, o:nClrText := 65535, o:nClrText := 0 ), ) } )

RETURN( NIL)

// --------------------------

FUNCTION CHANGE_DBF()

IF nDBF > 0 .and. nDBF < 10
	IF nDBF = 1
		NET_USE (c_Path + "CUST1.dbf", "CUST1", 3,.T.) 
		DBSELECTAREA("CUST1")
	ELSEIF nDBF = 2
		NET_USE (c_Path + "CUST2.dbf", "CUST2", 3,.T.) 
		DBSELECTAREA("CUST2")
	ELSEIF nDBF = 3
		NET_USE (c_Path + "CUST3.dbf", "CUST3", 3,.T.) 
		DBSELECTAREA("CUST3")
	ELSEIF nDBF = 4
		NET_USE (c_Path + "CUST4.dbf", "CUST4", 3,.T.) 
		DBSELECTAREA("CUST4")
	ELSEIF nDBF = 5
		NET_USE (c_Path + "CUST5.dbf", "CUST5", 3,.T.) 
		DBSELECTAREA("CUST5")
	ELSEIF nDBF = 6
		NET_USE (c_Path + "CUST6.dbf", "CUST6", 3,.T.) 
		DBSELECTAREA("CUST6")
	ELSEIF nDBF = 7
		NET_USE (c_Path + "CUST7.dbf", "CUST7", 3,.T.) 
		DBSELECTAREA("CUST7")
	ELSEIF nDBF = 8
		NET_USE (c_Path + "CUST8.dbf", "CUST8", 3,.T.) 
		DBSELECTAREA("CUST8")
	ELSEIF nDBF = 9
		NET_USE (c_Path + "CUST9.dbf", "CUST9", 3,.T.) 
		DBSELECTAREA("CUST9")
	ENDIF
ELSE
	nDBF := 1
	NET_USE (c_Path + "CUST1.dbf", "CUST1", 3,.T.) 
	DBSELECTAREA("CUST1")
ENDIF

nCounter := 0

RETURN( NIL)

// --------------------------

FUNCTION MAKE_INDEX( oMeter1, nRecPos, oImage, oTextFont2 )
LOCAL nColor := 255

nFCount := 1
nCounter := 0
nRecords := RECCOUNT()
oMeter1:nTotal := nRecords

SET_SPEED()

DBGOTOP()
IF NET_FLOCK ( 3 )

	// nStart := TIME()

	ORDCONDSET( ;								// <cForCondition>
				, ;								// <bForCondition>
				, .T. ;							// <lAll>
				, { || lRun = .T. } ;					// <bWhileCondition> break if lRun = .F.
				, { || nRecPos += nSpeed, ;			// <bEval>
				        nCounter := ORDKEYNO(), ;
					SLEEP( nDelay ), ;				// slowdown 
					SET_ANI( oImage, @nRecPos ), ;	// animation
					oMeter1:Set( nRecPos ), ;			// position>
					SysRefresh() } ;					// refresh
				       , nSpeed ;						// nInterval
				       , 1 ;							// <nStart ( first record )>
				       , , ,.F., .F., .F. ;					// <nRecords, nRecord, lRest, lDescend, lAdditive>
				       , .T., .F., .F. ) 					// <lCurrent>, <lCustom>, <lNoOptimize>
	ORDCREATE( ,"CUST1",	 "LAST", {|| LAST }, .F. )

	// nEnd := TIME()
	// MsgAlert( "Start : " + nStart + CRLF + ;
	//                "End : " + nEnd, "Seconds" )

	nRecPos = oMeter1:nTotal
	oMeter1:Set( nRecPos )

	oMeter1:bPainted := {|| oMeter1:Say( oMeter1:nHeight / 4.0, ( oMeter1:nWidth/2 ) -40, STR( nRecords ), , ,oTextFont2 , .t., .t., 0 ) }  
	nCounter := 0
	oImage:SetBMP( "C_30" )	// start-image

	NET_ULOCK()

ENDIF

RETURN NIL   

// ------------------

FUNCTION SET_SPEED() 

nSpeed := INT( nRecords / nStep ) // higher value is slower
IF nSpeed < 1
	nSpeed := 1
ENDIF	

RETURN NIL

//------------------ ANIMATION -----------

FUNCTION SET_ANI( oImage, nRecPos )
LOCAL nSplit := nRecords / 3.33

nFCount++
IF nFCount > nFrames
	nFCount := 1 								// if max, set animation to 1
ENDIF

IF cType <> "B_"								// normal style
	oImage:SetBMP( cType + LTRIM(STR(nFCount)) )	 
ELSEIF cType = "B_" .and. nRecpos <= nSplit			// different colors after 33.3 % and 66.9 %
	oImage:SetBMP( "E_" + LTRIM(STR(nFCount)) )
ELSEIF cType = "B_" .and. nRecpos > nSplit  .and. nRecpos < nSplit * 2
	oImage:SetBMP( "D_" + LTRIM(STR(nFCount)) )
ELSEIF cType = "B_" .and. nRecpos > nSplit * 2
	oImage:SetBMP( "B_" + LTRIM(STR(nFCount)) )
ENDIF

RETURN NIL

// ---------  INI Read ------------------------
 
FUNCTION GET_INI()
LOCAL oIni, cIniFile := c_path + "SETTING.ini"

IF !FILE ( c_path + "SETTING.ini" )
	SAVE_INI()
ELSE
	INI oIni FILE c_path + "SETTING.INI"
		cType		:= GetPvProfString(		"VALUES",		"Type",		"A_"		, cIniFile ) 
		nDBF		:= Val(GetPvProfString(	"VALUES",		"DBF",		"5"		, cIniFile ) )		
		nFrames		:= Val(GetPvProfString(	"VALUES",		"Frames",		"20"		, cIniFile ) )		
		nStep		:= Val(GetPvProfString(	"VALUES",		"Step",		"20"		, cIniFile ) )		
		nDelay		:= Val(GetPvProfString(	"VALUES",		"Delay",		"0"		, cIniFile ) )		
		nBrush		:= Val(GetPvProfString(	"VALUES",		"Brush",		"3"		, cIniFile ) )		
	ENDINI
ENDIF

RETURN( NIL )

// ---------  INI Write------------------------

FUNCTION SAVE_INI()
LOCAL cIniFile := c_path + "SETTING.ini"

WritePProString( "VALUES", "Type",		cType,				cIniFile ) 
WritePProString( "VALUES", "DBF",		ALLTRIM(STR(nDBF)),	cIniFile ) 
WritePProString( "VALUES", "Frames",	ALLTRIM(STR(nFrames)),	cIniFile ) 
WritePProString( "VALUES", "Step",		ALLTRIM(STR(nStep)),	cIniFile ) 
WritePProString( "VALUES", "Delay",		ALLTRIM(STR(nDelay)),	cIniFile ) 
WritePProString( "VALUES", "Brush",		ALLTRIM(STR(nBrush)),	cIniFile ) 

RETURN( NIL )

// ----------------------------

FUNCTION MAIN_HELP(oTextFont1)
LOCAL oDlg2, oSay1, oSay2, oSay3, cText1, cText2, oBtn1

DEFINE DIALOG oDlg2 ;
FROM  0, 0 TO 460, 500 PIXEL TITLE "HELP "  ICON "FAVORITE"   

cText1 := "9 different DBF's are included, to test the speed during indexing" + CRLF + ;
	"3 different animations are defined and saved inside a DLL" + CRLF + ;
	"The second style changes the color after reaching 33.3 and 66.6 %" + CRLF + ;
	"The animation-style and backgrd. can be changed during indexing" + CRLF + ;
	"You can break indexing with the < Stop > - button at any time."

cText2 := "The speed is calculated using < steps > and < delay >" + CRLF + ;
	"The speed will be always the same." + CRLF + ;
	"It doesn't matter if using a DBF with 50 or 100000 records" + CRLF + ;
	"Inside the meter, the record-nummer is shown during indexing." + CRLF + ;
	"At the end, the total of the records is shown." + CRLF + ;
	"The values of < delay > defines a SLEEP during indexing " + CRLF + ;
	"The values of < steps > are used for the calc. to adjust the speed." + CRLF + ;
	"A greater value slowes down the speed the same the delay-value." + CRLF + ;
	"In case the step-value > records, step 1 is used."

@ 5, 10 GET oSay1 VAR cText1 MEMO OF oDlg2 SIZE 230, 70 PIXEL FONT oTextFont1 READONLY update

@ 85, 10 GET oSay2 VAR cText2 MEMO OF oDlg2 SIZE 230, 110 PIXEL FONT oTextFont1 READONLY update


@ 205, 166 BTNBMP oBtn1 SIZE 60, 20 OF oDlg2  2007 ;
FILENAME  c_path1 + "Exit.bmp" ;
LEFT ;
PROMPT "&Exit" ;
FONT oTextFont1 ;
ACTION oDlg2:End() 
oBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 10526975, 16777215 }, ;
	  { 0.5, 16777215, 10526975 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oBtn1:nLayout := 2
oBtn1:SetColor( 128 )
oBtn1:cTooltip :=  { "Exit Help","EXIT", 1, CLR_BLACK, 14089979 }

ACTIVATE DIALOG oDlg2 CENTERED ;
ON INIT DRAW_BACK( oDlg2, 3, 16762767, 16773088, .T., 0.2, "Marble.bmp" , "Picture.jpg" )

RETURN( NIL )

// ---------- NET - FUNCTIONS ----------------------------
// --------------------------------------------------------------------

FUNCTION NET_USE ( cDBName, cAlias, nTrials, lNet )
LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTrcount   := nTrials
YesNo := .F.
nTime := 2
// SHARED    all Users
// EXCLUSIVE  1 User

IF File( cDBName )
	nTrials := nTrcount
	DO WHILE !lOpen
		DO WHILE .T.
			IF !lNet
				USE &cDBName ALIAS &cAlias NEW EXCLUSIVE
			ELSE
				USE &cDBName ALIAS &cAlias NEW SHARED
			ENDIF
			IF !NetErr()
				lReturn   := .T.
				lOpen     := .T.
				nTrials := 0
			ELSE
				IF lNet = .T.
					Status := "SHARED"
				ELSE
					Status := "EXCLUSIVE"
				ENDIF
				IF nTrcount = nTrials
					xName := WNetGetUser()
					IF MsgYesNo( "Open " + Status + "  of " + upper(cDBName) + " not possible !" + ;
			                                       " try again ?", "Network-error -> &xName !" )
						nTrials := nTrcount
						YesNo := .T.
					ELSE
						nTrials := 0
						YesNo := .F.
					ENDIF
				ENDIF
				IF YesNo = .T.
					nTrials --
					IF nTrials > 0 .AND. nTime > 0
						NET_WAIT ( nTrcount, nTrials, nTime)
					ENDIF
					IF nTrials = 0
						nTrials := nTrcount
					ENDIF
				ELSE
					lReturn   := .F.
					lOpen     := .T.
					nTrials := 0
				ENDIF
			ENDIF
			IF nTrials = 0
				lOpen := .T.
				EXIT
			ENDIF
		ENDDO
	ENDDO
ELSE
	nMsgBox ("File -> " + cDBName + " is missing !", "Attention !")
	SET RESOURCES to
	set _3DLOOK OFF
	FreeLibrary()
	Close database
	QUIT
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_CLOSE( nTrials, nTime )

LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTtrcount   := nTrials
YesNo    := .F.

cDBName := DBF()

DO WHILE !lOpen
	DO WHILE nTrials > 0
		USE
		IF NetErr()
			nTrials --
			IF MsgYesNo( "Close of file : " + upper(cDBName) + " not possible !" + ;
				" Try again ?", "Network-Error !" )
				lOpen :=.T.
				nTrials := ntrcount
				IF nTrials > 0 .AND. nTime > 0
					NET_WAIT ( nTrcount, nTrials, nTime)
				ENDIF
			ELSE
				lReturn   := .F.
				lOpen     := .T.
				nTrials := 0
			ENDIF
		ELSE
			lReturn   := .T.
			lOpen     := .T.
			nTrials := 0
		ENDIF
	ENDDO
ENDDO

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_RLOCK( nTrials, nTime )
LOCAL   lReturn   := .F.
LOCAL   nTrcount   := 0
LOCAL   nZSek     := 0
nTrcount := nTrials

DO WHILE !lReturn
	DO WHILE nTrials > 0
		IF !RLock()
			nTrials --
			IF nTrials > 0 .AND. nTime > 0
				NET_WAIT ( nTrcount, nTrials, nTime )
			ENDIF
		ELSE
			lReturn := .T.
			EXIT
		ENDIF
	ENDDO
	IF nTrials = 0
		IF MsgYesNo( "Not possible, to lock the record !" + ;
				       " Try again ?", "Network Error !" )
			nTrials := nTrcount
		ELSE
			lReturn := .F.
			EXIT
		ENDIF
	ENDIF
ENDDO
IF lReturn = .F.
	nMsgBox ("Files are not saved !!!", "Attention !")
ENDIF

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_ULOCK()

LOCAL   lReturn   := .F.

IF len(Fieldname(1)) > 0                     
	UNLOCK                                      
ENDIF

RETURN lReturn

// -----------------------

FUNCTION NET_FLOCK ( nTrials )
LOCAL lReturn   := .F., nTrCount := nTrials

cDBName := DBF()

DO WHILE nTrcount <= nTrials
	IF !FLock()
		nTrials --
		IF nTrials > 0 
			NET_WAIT ( nTrCount, nTrials )
		ENDIF
	ELSE
		lReturn := .T.
		EXIT
	ENDIF
	IF nTrials = 0
		IF MsgYesNo( "File-lock of " + upper(cDBName) + " not possible !" + ;
                             "Try again ?", "Network Error !" )
			nTrials := nTrcount
		ELSE
			lReturn := .F.
			nTrials := nTrcount
			EXIT
		ENDIF
	ENDIF
ENDDO

IF lReturn = .F.
	nMsgBox ("Not possible to look " + upper(cDBName) + "  !!!", "Attention !")
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_WAIT ( nTrcount, nTrials )

local oMeter, oText1

MsgMeter( { | oMeter, oText1 | ;
SHOW_WAIT(nTrcount, nTrials, oMeter, oText1) } , ;
"rest trials : " + LTRIM(STR(nTrials)) + ". trial..." )

RETURN nil

// ----------------------

STATIC FUNCTION SHOW_WAIT( nTrcount, nTrials, oMeter, oText1 )

nTime := 2
oMeter:nTotal = nTrcount
nZSek := Seconds()
oText1:SetText( "rest of trials : " + ltrim(str(nTrials)))
oMeter:Set( nTrials )
SysRefresh()

DO WHILE Seconds() < nZSek + nTime
ENDDO

RETURN nil

// -----------

DLL32 FUNCTION BWCCRegister( hInst AS LONG ) AS WORD PASCAL LIB "Anibtn.DLL"

